[Solution] 973. K Closest Points to Origin
Posted downstream-1998
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了[Solution] 973. K Closest Points to Origin相关的知识,希望对你有一定的参考价值。
- Difficulty: Easy
Problem
We have a list of points
on the plane. Find the K
closest points to the origin (0, 0)
.
(Here, the distance between two points on a plane is the Euclidean distance.)
You may return the answer in any order. The answer is guaranteed to be unique (except for the order that it is in.)
Example 1:
Input: points = [[1, 3], [-2, 2]], K = 1
Output: [[-2, 2]]
Explanation:
The distance between (1, 3) and the origin is sqrt(10).
The distance between (-2, 2) and the origin is sqrt(8).
Since sqrt(8) < sqrt(10), (-2, 2) is closer to the origin.
We only want the closest K = 1 points from the origin, so the answer is just [[-2, 2]].
Example 2:
Input: points = [[3, 3], [5, -1], [-2, 4]], K = 2
Output: [[3, 3], [-2, 4]]
(The answer [[-2, 4], [3, 3]] would also be accepted.)
Note:
1 <= K <= points.length <= 10000
-10000 < points[i][0] < 10000
-10000 < points[i][1] < 10000
Related Topics
Math, Divide and Conquer, Sort
Solution
解法显而易见,按照到原点的距离升序排列,取出前 K 个即可。由于 $f(x) = sqrt{x}$ 在其定义域上单调递增,故只需要计算根号内的 $x$,即 $x^2 + y^2$ 即可。
public class Solution
{
public int[][] KClosest(int[][] points, int K)
{
Array.Sort(points, delegate (int[] x, int[] y)
{
return (x[0] * x[0] + x[1] * x[1]) - (y[0] * y[0] + y[1] * y[1]);
});
int[][] ret = new int[K][];
Array.Copy(points, ret, K);
return ret;
}
}
在查看其他人的解答时,发现了如下解答(这个解答的作者的 LINQ 玩得很熟)
// no need to sqrt sinc we only want
public class Solution
{
public int[][] KClosest(int[][] points, int K)
{
return points
.OrderBy(x => x[0] * x[0] + x[1] * x[1])
.Take(K)
.ToArray();
}
}
以上是关于[Solution] 973. K Closest Points to Origin的主要内容,如果未能解决你的问题,请参考以下文章
LeetCode 973. K Closest Points to Origin
LeetCode 973. K Closest Points to Origin
LC 973. K Closest Points to Origin
[LC] 973. K Closest Points to Origin